#include "easysock.h"

int create_socket(int network, char transport) {  
	int domain;
	int type;

	if (network == 4) {
		domain = AF_INET;
	} else if (network == 6) {
		domain = AF_INET6;
	} else {
		return -1;
	}

	if (transport == 'T') {
		type = SOCK_STREAM;
	} else if (transport == 'U') {
		type = SOCK_DGRAM;
	} else {
		return -1;
	}

	int newSock = socket(domain,type,0);
	return newSock;
}


void create_addr(int network, char* address, int port,struct sockaddr* dest) {
	if (network == 4) {
		struct sockaddr_in listen_address;
		
		listen_address.sin_family = AF_INET;
		listen_address.sin_port = htons(port);
		inet_pton(AF_INET,address,&listen_address.sin_addr);
		memcpy(dest,&listen_address,sizeof(listen_address));
		return;	

	} else if (network == 6) {
		struct sockaddr_in6 listen_ipv6;
		listen_ipv6.sin6_family = AF_INET6;
		listen_ipv6.sin6_port = htons(port);
		inet_pton(AF_INET6,address,&listen_ipv6.sin6_addr);
		memcpy(dest,&listen_ipv6,sizeof(listen_ipv6));
		return;

	} else {
		exit(-2);
	}
		
}

int create_local (int network, char transport, char* address, int port,struct sockaddr* addr_struct) {
	int socket = create_socket(network,transport);
	if (socket == -1) {
		exit(-1);
	}
	create_addr(network,address,port,addr_struct);
	int addrlen = sizeof(*addr_struct);
	int i = bind (socket,addr_struct,(socklen_t)addrlen);
	if (i < 0) {
		printf("Something went wrong: %s\n",strerror(errno));
		exit(-3);
	}
	return socket;
}

int create_remote (int network,char transport,char* address,int port) {


	int socket = create_socket(network,transport);
	if (socket == -1) {
                exit(-1);
        }
	struct sockaddr remote_addr_struct;
        create_addr(network,address,port,&remote_addr_struct);
        int addrlen = sizeof(remote_addr_struct);
        int i = connect(socket,&remote_addr_struct,(socklen_t)addrlen);
	if (i < 0) {
		printf("Something went wrong: %s\n",strerror(errno));
		exit(-3);
	}
        return socket;
}
